#include "Product.h"


void Product::NewProduct() {
	std::cout << "\tEnter the warehouse number:";
	std::cin >> number_warehouse;
	std::cout << "\tEnter the product code:";
	std::cin >> code;
	std::cout << "\tEnter the product name:";
	std::cin >> name;
	std::cout << "\tEnter the date of receipt to the warehouse:" << std::endl << "\t\tday:";
	std::cin >> date_day;
	std::cout << "\t\tmonth:";
	std::cin >> date_month;
	std::cout << "\t\tyear:";
	std::cin >> date_year;
	std::cout << "\tEnter the retention period in days:";
	std::cin >> shelf_life;
	std::cout << "\tEnter the number of units of the product:";
	std::cin >> quantity;
	std::cout << "\tEnter the unit price:";
	std::cin >> price;
}

void Product::Output_in_file(std::ofstream& file) {
	file << number_warehouse << " " << code << " " << name << " " <<
		date_day << " " << date_month << " " << date_year << " " <<
		shelf_life << " " << quantity << " " << price << std::endl;
}
bool Product::Output_from_file(std::ifstream& file) {
	if (file >> number_warehouse >> code >> name >> date_day >> date_month >> date_year >>
		shelf_life >> quantity >> price) return true;
	else return false;
}

int Product::date_in_days() {
	return date_year * 365 + date_month * 30 + date_day;
}

int Product::Output_number_warehouse() {
	return number_warehouse;
}
int Product::Output_code() {
	return code;
}
std::vector<int> Product::Output_date() {
	std::vector<int> date;
	date.push_back(date_day);
	date.push_back(date_month);
	date.push_back(date_year);
	return date;
}
int Product::Output_shelf_life() {
	return shelf_life;
}

std::string Product::Output_name() {
	return name;
}

int Product::Output_quantity() {
	return quantity;
}

int Product::Output_price() {
	return price;
}





Product& List_Product::operator[](size_t num) {
	return map_Product[num];
}



void List_Product::Output_from_file(std::ifstream& file) {
	Product elem;
	while (elem.Output_from_file(file)) {
		map_Product[++size] = elem;
	}
}

void List_Product::Output_in_file(std::ofstream& file) {
	for_each(map_Product.begin(), map_Product.end(), [&](auto& elem) {
		elem.second.Output_in_file(file);
		});
}

std::map<size_t, Product>& List_Product::Output_map_Product() {
	return map_Product;
}

List_Product List_Product::Search_by_warehouse_number() {
	int number;
	std::cout << "Enter the warehouse number:";
	std::cin >> number;
	List_Product result;
	for (auto& i : map_Product) {
		if (i.second.Output_number_warehouse() == number) result[++(result.size)]=i.second;
	}
	return result;
}

List_Product List_Product::Search_by_product_code() {
	int code;
	std::cout << "Enter the product code:";
	std::cin >> code;
	List_Product result;
	for (auto& i : map_Product) {
		if (i.second.Output_code() == code) result[++(result.size)] = i.second;
	}
	return result;
}

List_Product List_Product::Search_by_date_of_receipt() {
	int day,month,year;
	std::cout << "Enter the date:" << std::endl;
	std::cout << "\tday: ";
	std::cin >> day;
	std::cout << "\tmonth: ";
	std::cin >> month;
	std::cout << "\tyear: ";
	std::cin >> year;
	std::vector<int> date;
	List_Product result;
	for (auto& i : map_Product) {
		date = i.second.Output_date();
		if (date.at(0)==day || date.at(1)==month || date.at(2)==year)result[++(result.size)] = i.second;
	}
	return result;
}

List_Product List_Product::Search_by_shelf_life() {
	bool overdue_or_no;
	int day,month,year,date_in_days;
	std::cout << "Find..." << std::endl
		<< "\t1 - expired products" << std::endl
		<< "\t0 - non-expired products"<<std::endl;
	std::cin >> overdue_or_no;
	std::cout << "Enter today's date:" << std::endl;
	std::cout << "\tday: ";
	std::cin >> day;
	std::cout << "\tmonth: ";
	std::cin >> month;
	std::cout << "\tyear: ";
	std::cin >> year;
	date_in_days= year * 365 + month * 30 + day;
	List_Product result;
	if (overdue_or_no == 1) {
		for (auto& i : map_Product) {
			if(i.second.date_in_days()+i.second.Output_shelf_life()<=date_in_days)result[++(result.size)] = i.second;
		}
	}
	else {
		for (auto& i : map_Product) {
			if (i.second.date_in_days() + i.second.Output_shelf_life() > date_in_days)result[++(result.size)] = i.second;
		}
	}
	return result;
}