#pragma once
#include <iostream>
#include <algorithm>
#include <map>
#include <fstream>
#include <vector>

class Product {
private:
	int number_warehouse=0;        // 
	int code=0;          // 
	std::string name;       //         
	int date_day=0;         //   
	int date_month=0;
	int date_year=0;
	int shelf_life=0;     //   
	int quantity=0;       //  
	int price=0;          //  
public:
	Product() = default;
	~Product() = default;

	void NewProduct();
	void Output_in_file(std::ofstream& file);
	bool Output_from_file(std::ifstream& file);

	int date_in_days();
	int Output_number_warehouse();
	int Output_code();
	std::string Output_name();
	std::vector<int> Output_date();
	int Output_shelf_life();
	int Output_quantity();
	int Output_price();
};

class List_Product {
private:
	std::map<size_t, Product> map_Product;
	size_t size = 0;
public:
	List_Product() = default;
	Product& operator[](size_t num);

	std::map<size_t, Product>& Output_map_Product();

	void Output_from_file(std::ifstream& file);
	void Output_in_file(std::ofstream& file);

	List_Product Search_by_warehouse_number();
	List_Product Search_by_product_code();
	List_Product Search_by_date_of_receipt();
	List_Product Search_by_shelf_life();

};


void Primary_input(const std::string& filename);
void Add_to_file(const std::string& filename);
void Delete_an_record(const std::string& filename);
void Replace_record(const std::string& filename);
void Search_for_records(const std::string& filename);
void Convert_to_a_text_file(const std::string& filename);